#include "main.h"

extern char     asciitable[260];
extern int      bottoms;
int             shortkludge = 0;
int             mailinglists = 0;

char newskludge[1024];

extern int safethreads;
/* #define logconfigreads */
extern int debuguserscfg=0;

int fastlookup=0;

void 
readsequence(void)
{
	int             handle = sopen("SEQUENCE.GIG", O_BINARY | O_RDONLY, SH_DENYWR, S_IREAD);
	if (handle < 0) {
		sequence = 0;
		errormsg("Could not open SEQUENCE.GIG, starting at 0.");
		return;
	}
	read(handle, &sequence, sizeof(sequence));
	read(handle, &dseq, sizeof(dseq));
	close(handle);
	startsequence = sequence;
}
void 
writesequence(void)
{
	int             handle = sopen("SEQUENCE.GIG", O_BINARY | O_CREAT | O_TRUNC | O_RDWR, SH_DENYRW, S_IWRITE);
	if (handle < 0) {
		sequence = 0;
		errormsg("Could not create SEQUENCE.GIG");
		return;
	}
	write(handle, &sequence, sizeof(sequence));
	write(handle, &dseq, sizeof(dseq));
	close(handle);
}

int 
isfido(char *search)
{
	char            s[256];
	strcpy(s, "\n");
	strcat(s, search);
	strupr(s);
	if (findstring(echos, s))
		return 1;
	else
		return 0;
}

//__memline
char           *
nextmemoryline(char *position)
{
	static char     line[LINESIZE];
	register int    pos = 0;
	register char   ch;
	line[0] = 0;
	if (!position)
		goto quit;
loop:
	ch = *position++;	/* should move position */
	switch (ch) {
	case 0:
		position--;
		goto quit;	/* put it back! */
	case 10:
		goto quit;
	case 13:
		goto loop;
	default:
		line[pos++] = ch;
		line[pos] = 0;	/* truncate line */
		goto loop;
	}
quit:
	__memline = pos;
	return line;
}


char           *
group2echo(char *usenet)
{
	char            search[LINESIZE];
char fastlbuf[LINESIZE];
	static char     echo[LINESIZE];
	char           *p;
	char           *position;
	char           *action;
	char           *newsgroup;
	char           *fidoecho;	/* char *moderator; */
	char           *remainder;


/* If fast lookup is enabled, attempt to blaze through,
   *assuming* that all entries are in the form of 
     = alt.newsgroup.name ALT.NEWSGROUP.NAME
     [-------------------]
   The section starting with the "=" and ending with the space
   will be important integral parts of quickly locating
   the correct newsgroup name.  It will be assumed
   that no "+/-" marks will be cound, nor "!" marks.
*/
  

       if (fastlookup) {
           sprintf(fastlbuf,"= %s ",usenet);
           position=findstring(mapping,fastlbuf);
           if (!position) {  
             /* nothing found! */
           echo[0]=0;return echo;
            }
      } else {
         /* we're not attempting the fast lookup code here */
	position = mapping;
       }
	strcpy(search, usenet);
	echo[0] = 0;
	while (*position) {
		p = nextmemoryline(position);	/* position should be
						 * incremented.. */
		position += __memline + 1;
		action = strtok(p, " ,");
		newsgroup = strtok(NULL, " ,");
		fidoecho = strtok(NULL, " ,");
		remainder = strtok(NULL, "\n");
		if (action)
			if (newsgroup)
				if (match(newsgroup, search)) {
					switch (*action) {
					case '!':
						strcpy(echo, "!");
						if (fidoecho)
							sprintf(echo + 1, " %s", fidoecho);
						if (remainder)
							sprintf(echo + strlen(echo), " %s", remainder);
						p = strtok(NULL, " ,");
						if (p)
							sprintf(echo + strlen(echo), " %s", p);
						return echo;

					case '+':
						if (fidoecho) {
							strcpy(echo, fidoecho);
							strupr(echo);
							return echo;
						}
						strcpy(echo, usenet);
						break;	/* keep, but check for
							 * other conditionals */
					case '<':
						echo[0] = 0;
						return echo;	/* to usenet only, kill
								 * it */
					case '-':
						echo[0] = 0;
						break;	/* kill */
					case '>':	/* to fidonet only, same
							 * as =  in this
							 * syntax.. */
					case '=':
						if (fidoecho)
							strcpy(echo, fidoecho);
						else
							strcpy(echo, usenet);
						if (strpbrk(echo, "*?[]"))
							strcpy(echo, usenet);
						strupr(echo);
						return echo;
					}
				}
	}
	strupr(echo);
	return echo;
}

char           *
mapmailinglist(char *usenet, char *from)
{
	char            search[LINESIZE];
 char search2[LINESIZE];
	static char     echo[LINESIZE];
	char            HEI[256];
	char           *p;
	char           *position;
	char           *action;
	char           *newsgroup;
	char           *fidoecho;
	char           *moderator;
char *fromwhere;

int keep;
		strcpy(echo, usenet);
		strlwr(echo);
		//temporary use ECHO as a lowercase buffer
			strcpy(HEI, mysite);
		strlwr(HEI);
		strcpy(search, cleanup(echo, HEI));

 strcpy(search2,from); strlwr(search2);

	position = mapping;
	echo[0] = 0;
	while (*position) {
		p = nextmemoryline(position);	/* position should be
						 * incremented.. */
		position += __memline + 1;
		if (*p == '@') {
                        keep=0;
			action = strtok(p, " ,");
			newsgroup = strtok(NULL, " ,");	/* actually mail address */
			fidoecho = strtok(NULL, " ,");	/* actually fido echo */
			moderator = strtok(NULL, " ,");
                        fromwhere = strtok(NULL, " ,"); /* whre it's from */
if (!fromwhere) fromwhere="-"; /* don't care */

			if (!fidoecho)
				continue;
                        if (strcmp(newsgroup,"-")) 
			  newsgroup = cleanup(newsgroup, HEI);
			strlwr(newsgroup);

                       if (strcmp(fromwhere,"-")==NULL)
                       if (strcmp(newsgroup,"-")==NULL)
                            continue; /* can't be both - */

                        keep=0;
			if (newsgroup) { 
                           if (strcmp(newsgroup,search)==NULL) keep=1;
                           if (strcmp(newsgroup,"-")==NULL) keep=1;
                            }
                            if (keep==0) continue;

                        keep=0;
                        if (strcmp(fromwhere,"-")==NULL) keep=1;
                        if (strcmp(search2,fromwhere)==NULL) keep=1;
                        if (strstr(search2,fromwhere)) keep=1;
                       if (keep==0) continue;
                       return fidoecho;
		}
	}
	strupr(echo);
	return echo;
}

char           *
echo2group(char *usenet)
{
	char            search[LINESIZE];
	char            echo[LINESIZE];

	char           *p;
	char           *position;
	char           *action;
	char           *newsgroup;
	char           *fidoecho;
	char           *moderator;
char *fromwhere;
	char            buffer[256];
	strcpy(search, usenet);
	strupr(search);
        newskludge[0]=0;
	position = mapping;
	echo[0] = 0;
	while (*position) {
		p = nextmemoryline(position);	/* position should be
						 * incremented.. */
		position += __memline + 1;
		action = strtok(p, " ,");
		newsgroup = strtok(NULL, " ,");
		if (!newsgroup)
			newsgroup = "";
strcpy(newskludge,newsgroup);
		fidoecho = strtok(NULL, " ,");
		if (!fidoecho) {
			strcpy(buffer, newsgroup);
			fidoecho = buffer;
		}
		if (fidoecho)
			strupr(fidoecho);
		moderator = strtok(NULL, " ,");
/*                fromwhere=strtok(NULL," ,");  not needed */
		if (fidoecho)
			if (match(fidoecho, search)) {
				switch (*action) {
				case '!':
					break;
					/* NOT for this context */
				case '-':
						echo[0] = 0;
					break;	/* don't keep me! but keep
						 * checking anyways */
				case '>':	/* to fidonet only, kill */
					echo[0] = 0;
					return "";
				case '@':	/* mailing list */
					if (!moderator)
						moderator = "NULL";
					if (!*moderator)
						moderator = "NULL";
					sprintf(echo, " %s", moderator);
					return echo;
				case '<':	/* one way, might be
						 * moderated */
				case '+':	/* + keepme! keep looking
						 * though.. */
				case '=':	/* or moderated newsgroup */
					if (fidoecho) {
						strcpy(echo, newsgroup);
						if (moderator)
							sprintf(echo + strlen(echo), " %s", moderator);
					} else
						strcpy(echo, usenet);
					if (strpbrk(echo, "*?"))
						/*has wildcards..subs original echo name instead.*/
						{
							strcpy(echo, search);
							strlwr(echo);
						}
					if (*action == '=')
						return echo;
					if (*action == '<')
						return echo;
					break;
					/* translate */
				}
			}
	}
	return echo;
}


char           *
configline(char *variable)
{
	char            search[LINESIZE];
	char           *p;
	char           *position;
	char           *verb;
	char           *data;
	int             len;
#ifdef logconfigreads
	printfh(logconfigs, "%s\r\n", variable);
#endif

	position = config;
	search[0] = '\n';
	strcpy(search + 1, variable);
	strupr(search);
	len = strlen(search);
loop:
	position = findstring(position, search);
	if (!position)
		return NULL;
	position++;
	p = nextmemoryline(position);	/* position should be incremented.. */
	position += __memline + 1;
	verb = strtok(p, " ,");
	data = strtok(NULL, "\r");	/* rest of line.. :-) */
	if (strcmp(verb, search + 1) == 0) {
		if (!data)
			data = "";
		while (*data == ' ')
			data++;
		return data;
	}
	if (position != config)
		position--;
	goto loop;
}
char           *findstring(char *buf, char *search);
int 
defined(char *config, char *variable)
{
	char            search[LINESIZE];
	char           *p;
	search[0] = '\n';	/* newline */
#ifdef logconfigreads
	printfh(logconfigs, "%s\r\n", variable);
#endif
	strcpy(search + 1, variable);
	strupr(search);
loop:
	p = findstring(config, search);
	if (!p)
		return 0;
	p += strlen(variable) + 1;
	if (*p == ' ')
		return 1;
	if (*p == '\n')
		return 1;
	config = p;
	goto loop;
}
int 
defined(char *variable)
{
	char            search[LINESIZE];
	char           *p;
	char           *cfg = config;

	search[0] = '\n';	/* newline */
#ifdef logconfigreads
	printfh(logconfigs, "%s\r\n", variable);
#endif
	strcpy(search + 1, variable);
	strupr(search);
loop:
	p = findstring(cfg, search);
	if (!p)
		return 0;
	p += strlen(variable) + 1;
	if (*p == ' ')
		return 1;
	if (*p == '\n')
		return 1;
	cfg = p;
	goto loop;
}



char           *
mapuser(char *username)
{
	char           *p;
	char           *position;
	char           *account;
	char           *info;
	char            realaccount[256];
	position = userstart;
	while (*position) {
		p = nextmemoryline(position);	/* position should be
						 * incremented.. */
		position += __memline + 1;
		account = strtok(p, " ,");
		info = strtok(NULL, "\r");	/* remainder of line */
		if (!username)
			username = "";
		if (!account)
			account = "";
		if (!info)
			info = "";
		while (*info == ' ')
			info++;

		strcpy(realaccount, cleanup(account, mysite));

		if (stricmp(realaccount, username) == 0)
			return info;
	}
	return NULL;
}
extern int      checkvalidfidonet;
char           *
mapaddress(char *person, char *address)
{
	char            buf[512];
	char           *p;
	FIDOADR         fidoadr;
	strcpy(buf, configstr("SENDTO"));
	p = strtok(buf, " ");
	if (!p)
		return NULL;
	fidoadr_split(p, &fidoadr);
	fidoadr.point = 0;
	strcpy(buf, address);

	if ((toupper(buf[0]) == 'F') || (toupper(buf[0]) == 'P'))
		goto fnz;

	p = strtok(buf, ".-_");
	if (!p)
		goto quit;
	if (!isdigit(*p))
		return NULL;
	fidoadr.node = atow(p);

	p = strtok(NULL, ".-_:/");
	if (!p)
		goto quit;
	if (!isdigit(*p))
		goto quit;
	//was return null;
	fidoadr.net = fidoadr.node;
	fidoadr.node = atow(p);

	p = strtok(NULL, ".-_:/");
	if (!p)
		goto quit;
	if (!isdigit(*p))
		goto quit;
	//was return null;
	fidoadr.point = atow(p);


	p = strtok(NULL, ".-_:/");
	if (!p)
		goto quit;
	if (!isdigit(*p))
		goto quit;
	//was return null;
	fidoadr.zone = fidoadr.net;
	fidoadr.net = fidoadr.node;
	fidoadr.node = fidoadr.point;
	fidoadr.point = atow(p);

quit:
	if (checkvalidfidonet)
		if (!validaddress(fidoadr.zone, fidoadr.net, fidoadr.node))
			return NULL;	/* not in the nodelist, buddy! */
	fidoadr_merge(buf, &fidoadr);
	strcat(buf, " ");
	strcat(buf, person);
	return buf;

fnz:

	p = strtok(buf, ".-_:/");
	if (p == NULL)
		return NULL;
	if (toupper(*p) == 'P') {
		fidoadr.point = atow(p + 1);
		goto fido;
	}
	if (toupper(*p) == 'F') {
		fidoadr.node = atow(p + 1);
		goto net;
	}
	return NULL;
fido:
	p = strtok(NULL, ".-_:/");
	if (p == NULL)
		return NULL;
	if (toupper(*p) != 'F')
		return NULL;
	fidoadr.node = atow(p + 1);
net:
	p = strtok(NULL, ".-_:/");
	if (p == NULL)
		return NULL;
	if (toupper(*p) != 'N')
		return NULL;
	fidoadr.net = atow(p + 1);
	/* zone: */
	p = strtok(NULL, ".-_:/");
	if (p == NULL)
		return NULL;
	if (toupper(*p) != 'Z')
		return NULL;
	fidoadr.zone = atow(p + 1);


	if (checkvalidfidonet)
		if (!validaddress(fidoadr.zone, fidoadr.net, fidoadr.node))
			return NULL;	/* not in the nodelist, buddy! */
	fidoadr_merge(buf, &fidoadr);
	strcat(buf, " ");
	strcat(buf, person);
	return buf;
}
char           *
mapsite(char *username)
{
	char            search[LINESIZE];
	char           *p;
	char           *position;
	char           *sitename;
	char           *info;
	char           *olduser = username;
	char            realaccount[256];
	char            realname[256];
	char            tempbuf[256];
	strcpy(realname, username);
	username = strstr(realname, "@");
	if (!username)
		return NULL;	/* not found */
	*username = 0;		/* shorten REALNAME to the real thing */
	username++;
	if (!*username)
		return NULL;	/* not found */

	while ((p = strstr(realname, ".")) != NULL)
		*p = ' ';	/* replace dots with spaces */

      while ((p=strstr(realname,"_ ")) !=NULL)
           *p='.'; /* replaces "_ " (was "_.") with ". "; */
      
      while ((p=strstr(realname,"_")) !=NULL)
         *p=' '; /* all remaining underscores to spaces */

	sprintf(search, "SITE %s ", username);
	position = sitestart;
	while (*position) {
		p = nextmemoryline(position);	/* position should be
						 * incremented.. */
		position += __memline + 1;
		sitename = strtok(p, " ,");
		info = strtok(NULL, "\r");	/* remainder of line */
		if (!info) {
			info = "";
			if (!sitename)
				sitename = "";
		}
		while (*info == ' ')
			info++;
		if (stristr(sitename, "*user"))
			//If the * user statement is used in this line..
		{
			strcpy(tempbuf, cleanup(sitename, mysite));
			sitename = strstr(tempbuf, "@");
			//jump over the * user part
				if (!sitename)
				sitename = "";
			else
				sitename++;
		}
		if (stricmp(sitename, username) == 0) {
			sprintf(realaccount, "%s %s", info, realname);
			if ((strnicmp(realaccount, "news ", 5) == 0)
			    || (strnicmp(realaccount, "echo ", 5) == 0)
				) {
				realaccount[5] = 0;
				strcat(realaccount, olduser);
				p = strchr(realaccount, '@');
				if (p)
					*p = 0;
			}
			return realaccount;
		}
	}
	/* bigreject: */
	if ((toupper(*username) != 'F') && (toupper(*username) != 'P') && (!isdigit(*username)))
		return NULL;
	return mapaddress(realname, username);
}
char           *
maplocal(char *username)
{
	char           *p;
	char            realaccount[256];
	char            realname[256];
	strcpy(realaccount, username);
	username = realaccount;

	if (strnicmp(realaccount, "root:", 5) == NULL)
		goto Local;	/* if it's to root */
	if (stricmp(realaccount, "root") == NULL)
		goto Local;	/* if it's to root:whatever */
	if (strpbrk(realaccount, "@!%") == NULL)
		if (0 == keepunknownusers)
			return "BOUNCE";	/* anything else? Bounce! */

	if (!strstr(realaccount, "@"))
		if (!strstr(realaccount, "!"))
			while ((p = strstr(username, ".")) != NULL)
				*p = ' ';	/* replace dots with spaces */
Local:
	sprintf(realname, "%s %s", sendtoaddress, realaccount);
	return realname;
}

char           *
configstr(char *variable)
{
	char           *p;
	p = configline(variable);
	if (p)
		if (*p)
			return p;
	return "";
}


void            initlogfile(void);

void            shorten(char *source);

int 
paramconfigs(void)
{
	int             index;
	if (_argc < 2)
		return 0;
	for (index = 1; index < _argc; index++)
		if (_argv[index][0])
			if (_argv[index][0] != '/')
				return 1;
	return 0;
}
char           *
paramswitch(char *lookfor)
{
	static char     buf[128];
	char            in[64];
	word            index;
	strcpy(in, lookfor);
	strupr(in);
	for (index = 0; index < _argc; index++) {
		strcpy(buf, _argv[index]);
		strupr(buf);
		if (strstr(buf, in) == buf)
			return buf;
	}
	return NULL;
}

int             sim_check(void);

void 
checksites(void)
{
	char           *p, *position, *oldposition;
	char            buf[512];
	char           *pattern, *fido;
	position = sitestart + 2;
	while (*position) {
		p = nextmemoryline(oldposition = position);
		position += __memline + 1;
		if (NULL == (pattern = strtok(p, " ")))
			pattern = "";
		if (NULL == (fido = strtok(NULL, " "))) {
			sprintf(buf, "SITE %s : No fidonet address given.\r\n", nextmemoryline(oldposition));
			goto gobad;
		}
		if ((stricmp(pattern, "fidonet")) ||
		    (stricmp(pattern, "fidonet.org")) ||
		    (stricmp(pattern, "gateway"))
			)
			continue;
		if (stristr(pattern, "*site") != NULL) {
			sprintf(buf, "SITE %s : Contains a *SITE variable, recursion not permited.\r\n", nextmemoryline(oldposition));
			goto gobad;
		}
		if (strstr(pattern, "_") != NULL) {
			sprintf(buf, "SITE %s : Contains _underscore_ character.\r\nSMTP mail protocals can not transfer addresses with _ in the site name.\r\n", nextmemoryline(oldposition));
			goto gobad;
		}
		if (strpbrk(pattern, "@!%.") != NULL) {
			if (stristr(pattern, "*user") == NULL) {
				sprintf(buf, "SITE %s : Contains no *user variable.\r\n\r\n"
					"Any site with the \"@!%%.\" characters must contain their ENTIRE address,\r\n"
					"including domain.  Example:  *user@some.site.org \r\n", nextmemoryline(oldposition));
		gobad:
				badbadbad(buf);
			}
			p = cleanup(pattern, "");
			if (p != NULL) {
				if (stristr(p, ".*fnz")) {
					sprintf(buf, "SITE %s : Contains bad *FNZ placement.\r\n", nextmemoryline(oldposition));
					goto gobad;
				}
				if (stristr(p, ".*ftn")) {
					sprintf(buf, "SITE %s : Contains bad *FTN placement.\r\n", nextmemoryline(oldposition));
					goto gobad;
				}
			}
		}
	}
}
void 
checkusers(void)
{
	char           *p, *position, *oldposition;
	char            buf[512];
	char           *pattern, *fido;
	position = userstart + 2;
	while (*position) {
		p = nextmemoryline(oldposition = position);
		position += __memline + 1;
		if (NULL == (pattern = strtok(p, " ")))
			pattern = "";
		if (NULL == (fido = strtok(NULL, " "))) {
			sprintf(buf, "USER %s : No fidonet address given.\r\n", nextmemoryline(oldposition));
			goto gobad;
		}
		if (stristr(pattern, "*user")) {
			sprintf(buf, "USER %s : Contains a *USER variable, recursion not permited.\r\n\r\n", nextmemoryline(oldposition));
			goto gobad;
		}
		if (
		    (stristr(pattern, "*SITE")) ||
		    (stristr(pattern, "*FNZ")) ||
		    (stristr(pattern, "*FTN"))) {
			sprintf(buf, "USER %s : User statements may not contain *SITE, *FNZ, or *FTN.\r\n\r\n", nextmemoryline(oldposition));
	gobad:
			badbadbad(buf);
		}
	}
}
void            readconfigfiles(char *filename);

void 
readconfig(char *fname)
{
	char           *p;
	long            l;
	char            filename[256];
	char            lastch = '\n';
	int             handle = 0;
	long            cfgsize = 0;
	int             i;


	strcpy(filename, fname);
	/* onemoretime: */
	cprintf("Reading Cfg..\r\n");

	readconfigfiles(filename);

	if ((!sitestart) || (!userstart) || (!keep_) || (!kill_) || (!hide_) || (!allow_) || (!fastreturn_) || (!blockaddress_))
		badbadbad("Could not allocate sub-buffers for configuration");

	while ((p = strstr(config, "\nFTPMAIL-")) != NULL) {
		p++;		/* move past the \n */
		memmove(p + 1, p, strlen(p) + 1);
		//insert a space
			strncpy(p, "FILESERV", 8);
	}
	if (paramswitch("/TEST"))
		strcat(config, "TEST\n");
	//test mode


		strupr(keep_);
	strupr(kill_);
	strupr(hide_);
	strupr(allow_);
	strupr(blockaddress_);

	initlogfile();
	if ((!mapping) || (strlen(mapping) < 4)) {
		errormsgstring("Warning: No mapping information found for translating newsgroups and echos!");
		sleep(3);
	}
	readsequence();
	strcpy(breakpoint, configstr("BREAKPOINT"));
	strcpy(mysite, configstr("MYSITE"));
	if (!*mysite)
		badbadbadcfg("MYSITE");

	strcpy(mypath, configstr("MYPATH"));
	if (!*mypath)
            strcpy(mypath, mysite);
        strcpy(forcepath,configstr("FORCEPATH"));
        
	strcpy(myfrom, configstr("MYFROM"));
	//centron.com hack
		if (myfrom[0])
		strcat(myfrom, "!");
	if (mypath[strlen(mypath) - 1] == '!')
		mypath[strlen(mypath) - 1] = 0;	/**/
	strcpy(myfeed, configstr("MYFEED"));
	if (!*myfeed)
		badbadbadcfg("MYFEED");
	strcpy(domain, configstr("DOMAIN"));
	if (!*domain)
		badbadbadcfg("DOMAIN");
	strcpy(seenby, configstr("SEEN-BY"));
	if (!*seenby)
		badbadbadcfg("SEEN-BY");
	strcpy(path, configstr("PATH"));
	if (!*path)
		errormsgstring("Warning: No PATH config line statement; non-fatal");
	strcpy(tzone, "TZ=");

	strcpy(tzone + 3, configstr("TZ"));
	if (!tzone[3])
		if ((p = getenv("TZ")) != NULL)
			strcpy(tzone + 3, p);
	if (!tzone[3])
		badbadbadcfg("TZ");
	strcpy(password, configstr("PASSWORD"));

	originmethod = organmethod = 0;

	strcpy(origin, configstr("ORIGIN=ORGANIZATION"));
	strcpy(origindef, configstr("ORIGIN"));
	if (defined("ORIGIN=ORGANIZATION"))
		originmethod = 1;



	strcpy(organ, configstr("ORGANIZATION=ORIGIN"));
	strcpy(organdef, configstr("ORGANIZATION"));
	if (defined("ORGANIZATION=ORIGIN"))
		organmethod = 1;


	p = configstr("GATEWAY");
	if ((!p) || (!*p))
		badbadbadcfg("GATEWAY");
	p = strtok(p, " ,");
	strcpy(gateway, p);
	fidoadr_split(gateway, &gatewayADDR);

	strcpy(originaddress, configstr("ORIGINADDRESS"));
	if (!originaddress[0])
		strcpy(originaddress, gateway);

	p = configstr("SENDTO");
	if ((!p) || (!*p))
		badbadbadcfg("SENDTO");
	p = strtok(p, " ,");
	strcpy(sendtoaddress, p);
	fidoadr_split(sendtoaddress, &sendtoADDR);

	if (!gatewayADDR.zone)
		if (!sendtoADDR.zone)
			gatewayADDR.zone = sendtoADDR.zone = 1;
	if (!gatewayADDR.zone)
		gatewayADDR.zone = sendtoADDR.zone;
	if (!sendtoADDR.zone)
		sendtoADDR.zone = gatewayADDR.zone;

	if (gatewayADDR.zone == sendtoADDR.zone)
		if (gatewayADDR.net == sendtoADDR.net)
			if (gatewayADDR.node == sendtoADDR.node)
				if (gatewayADDR.point == sendtoADDR.point)
					badbadbadcfg("Your GATEWAY and SENDTO address can NOT be the same!");
	fidoadr_merge(gateway, &gatewayADDR);
	fidoadr_merge(sendtoaddress, &sendtoADDR);

	maxpkt = atol(configstr("MAXPKT"));
	maxpkt = atol(configstr("MAXPKT"));
	maxmessage = atol(configstr("SPLIT"));
	if (maxmessage < 4000)
		maxmessage = 4000;
	if (!maxmessage)
		maxmessage = 15000;

	strcpy(mapstylelocal, configstr("MAPSTYLELOCAL"));
	if (!mapstylelocal[0])
		badbadbad("MAPSTYLELOCAL not defined (see the sample config file)");
	if (!stristr(mapstylelocal, "*user"))
		badbadbad("MAPSTYLELOCAL does not have a *USER variable (see the sample config file)");
	strcpy(mapstylesite, configstr("MAPSTYLESITE"));
	if (!mapstylesite[0])
		badbadbad("MAPSTYLESITE not defined");
	if (!stristr(mapstylesite, "*user"))
		badbadbad("MAPSTYLESITE does not have a *USER variable (see the sample config file)");
	if (!stristr(mapstylesite, "*site"))
		badbadbad("MAPSTYLESITE does not have a *SITE variable (see the sample config file)");
	if (maxpkt < 10000)
		maxpkt *= 1000;	/* k */
	linesplit = atoi(configstr("LINEBREAK"));
	if (!linesplit)
		atoi(configstr("LINESPLIT"));
	errormsgstring("Maximum FTSC .PKT size: %lu", maxpkt);

	strcpy(smallvsn, VERSION);
	strtok(smallvsn, " ");
	keepunknown = 0;
	keepunknown = defined("KEEPUNKNOWNSITES") | defined("KEEPUNKNOWN") | defined(keep_, "UNKNOWN") | defined(keep_, "UNKNOWNSITES");
	keepunknownusers = defined("KEEPUNKNOWNUSERS") | defined("KEEPUNKNOWN") | defined(keep_, "UNKNOWN") | defined(keep_, "UNKNOWNUSERS");
	fsc35 = defined("FSC35") | defined("FSC-35") | defined("FSC-38") | defined("FSC38");
	partial35 = defined("PARTIAL35") | defined("PARTIAL-35");
	do_news = do_fido = do_mail = 1;
	if (defined("SKIP_RMAIL"))
		do_mail = 0;
	if (defined("SKIP_RNEWS"))
		do_news = 0;
	if (defined("SKIP_MAIL"))
		do_mail = 0;
	if (defined("SKIP_NEWS"))
		do_news = 0;
	if ((paramswitch("/MAIL")) || (paramswitch("/NEWS")) || (paramswitch("/FIDO"))) {
		do_news = do_fido = do_mail = 0;
		if (paramswitch("/MAIL"))
			do_mail = 1;
		if (paramswitch("/NEWS"))
			do_news = 1;
		if (paramswitch("/FIDO"))
			do_fido = 1;
	}
	l = atol(configstr("SERIALNUMBER"));
	if (registered())
		sprintf(gigosig, "GIGO+ sn %lu at %s vsn %s", l, mysite, SHORTVER);
	else
		sprintf(gigosig, "GIGO unreg at %s vsn %s", mysite, SHORTVER);

	keep_news = 0;
	if ((defined("RNEWS_KEEP_ALL")))
		keep_news = 1;
	if ((defined("RNEWS_HIDE_ALL")))
		keep_news = 2;
	if ((defined(keep_, "NEWS")) || (defined(keep_, "NEWS:")))
		keep_news = 1;
	if ((defined(hide_, "NEWS")) || (defined(hide_, "NEWS:")))
		keep_news = 2;
	keep_mail = 0;
	if ((defined("RMAIL_KEEP_ALL")))
		keep_mail = 1;
	if ((defined("RMAIL_HIDE_ALL")))
		keep_mail = 2;
	if ((defined(keep_, "MAIL")) || (defined(keep_, "MAIL:")))
		keep_mail = 1;
	if ((defined(hide_, "MAIL")) || (defined(hide_, "MAIL:")))
		keep_mail = 2;


	//germans = (defined("GERMAN") || defined("GERMANS"));
	returnaddress_email = defined("RETURNADDRESS_EMAIL");
	if (returnaddress_email)
		strcpy(_returnaddress_email, configstr("RETURNADDRESS_EMAIL"));
	returnaddress_news = defined("RETURNADDRESS_NEWS");
	if (returnaddress_news)
		strcpy(_returnaddress_news, configstr("RETURNADDRESS_NEWS"));

	if ((!returnaddress_email) && (!returnaddress_news)) {
		returnaddress_news = returnaddress_email = defined("RETURNADDRESS");
		strcpy(_returnaddress_email, configstr("RETURNADDRESS"));
		strcpy(_returnaddress_news, configstr("RETURNADDRESS"));
	}
	if (!extraoption("IGNORE_CHARTER")) {
		if (defined("IGNORE_CHARTER"))
			errormsgstring("IGNORE_CHARTER key incorrect");
		if (!strstr(fastreturn_, "fidonet.org"))
			strcat(fastreturn_, "*.fidonet.org\n");
	} else
		errormsgstring("IGNORE_CHARTER key enabled");
	if (extraoption("NO_X-MAIL-AGENT"))
		xmail = 0;
	choosespools = defined("ROUTESPOOL");
	backwardsfeed = defined("BACKWARDSFEED");

	ftpmaildefault = atol(configstr("FILESERV-DEFAULT"));
	if (!ftpmaildefault)
		ftpmaildefault = 70000;
	if (ftpmaildefault < 1500)
		ftpmaildefault = 1500;
	ftpmailattach = defined("FILESERV-ATTACH") | defined("FILESERV-FILEATTACH");
	if (ftpmailattach) {
		if ((!*configstr("FILESERV-INBOUND")) || (!*configstr("FILESERV-HOLD")))
			badbadbad("FILESERV-ATTACH specified, but FILESERV-INBOUND and/or FILESERV-HOLD\r\n"
				  "are not defined.");
	}
	cmsg_cancel = (char) defined("CMSG_CANCEL");

	maxnewsgroups = atol(configstr("MAXNEWSGROUPS"));
	if (!maxnewsgroups)
		maxnewsgroups = 100;
	if (maxnewsgroups > 100)
		maxnewsgroups = 100;
	crlf = defined("CRLF");
	burt_juda_hack = defined("BURT_JUDA_HACK");
	davidnugent = defined("XQT_FROM_UUCP");
	checksites();
	checkusers();
	if (strstr(mysite, "_") || (strstr(domain, "_")))
		errormsgstring("Warning: MYSITE or DOMAIN names with _ (underscore) characters do not travel far on the internet (ie SMTP).");
	signatures = defined("SIGNATURES");
	nike = defined("NIKE") || defined("KEEPTHREADS") || defined("KEEP_THREADS");
	capturedefined = defined("CAPTURE") || defined("CAPTUREPRIV");
	translate_control = defined("TRANSLATE_CONTROL");
	delete_control = defined("DELETE_CONTROL");
	explicit_fastreturn = (defined("EXPLICIT_FASTRETURN") | defined("EXPLICIT-FASTRETURN") | defined("EXPLICITFASTRETURN"));
	eightbit = defined("8BIT");
	from_postmaster = defined("POSTMASTER_HACK");
	maxrmail = atol(configstr("MAXRMAIL"));
	if (maxrmail > 2000)
		maxrmail = 2000;
	if (maxrmail < 1)
		maxrmail = 240;
	bottoms = defined("BOTTOMHEADERS") || defined("BOTTOMS");
	multipleheaders = defined("MULTIPLEHEADERS") || bottoms;	/* BOTTOMS implies
									 * MULTIPLEHEADERS */
	shortkludge = atol(configstr("SHORTKLUDGE"));
	if (shortkludge == 0)
		if (defined("FASTECHO"))
			shortkludge = 79;
	p = configstr("TRANSLATE");
	if ((*p == '\"') && (p[strlen(p) - 1] == '\"')) {
		p[strlen(p) - 1] = 0;
		p++;
	}
	if (strlen(p) != 0)
		if (strlen(p) != 128)
			badbadbad("TRANSLATE table not 128 bytes long");
	memset(asciitable, '#', sizeof(asciitable));
	asciitable[256] = 0;
	for (i = 0; i < 128; i++)
		asciitable[i] = (unsigned char) i;
	if (p)
		strcpy(asciitable + 128, p);
	else
		strcpy(asciitable + 128,
		/*
		 * "
		 * 
		 *  "
		 */
		       "Cueaaaaceeeiiiaae%AooouuuOUc###faiounN--?++/*!<>###|++++++|+++++++++-++++++++=+++++++++++++#####abg#E###########=#####/~Oo.#n2*  "
			);
	TCPIP = defined("TCPIP");
	mailinglists = 0;
	if (strchr(mapping, '@'))
            mailinglists = 1;
        noftnto=defined("NO-X-FTN-TO");
        safethreads=defined("SAFETHREADS")||defined("SAFE_THREADS");
        debuguserscfg=defined("DEBUGUSERSCFG");
       fastlookup =defined("FASTLOOKUP");
       strcpy(flags,configstr("FLAGS"));
}
