#include "main.h"
#include "time.h"
#include "signal.h"

#define COMPILE_TIME 837381059
#define EXPIRE_TIME 852933059


#define __expires__ EXPIRE_TIME
char            __expiredate__[80] = "";

int             tron = 0;
void            makepath(char *);
extern int      usevideo;	/* turns on/off bconio */

void
foobartest(char *string, unsigned int number)
{

	FILE           *foobar;
	foobar = fopen("c:\\test.txt", "rt");
	if (foobar)
		fclose(foobar);
}

void            statusline(char *buffer);
void
TRACKCHECK(char *string, unsigned int number)
{
	char            buf[250];
	static unsigned long instance = 0;
	instance++;
	if (tron == 0)
		return;
	sprintf(buf, "Instance %lu   File:%s   Line:%u                                                   ", instance, string, number);
	statusline(buf);
	switch (_heapchk()) {
	case _HEAPOK:
	case _HEAPEMPTY:
		break;
	case _HEAPBADBEGIN:
	case _HEAPBADNODE:
		strcat(buf, " ERROR - HEAP IS DAMAGED\n");
		statusline(buf);
		delay(1000);
		break;
	}
	//foobartest(string, number);
	//delay(100);
}

void
errormsg(char *msg)
{
	log(msg);
}

void
errormsgstring(char *fmt,...)
{
	va_list         argptr;
	char            buffer[1024];
	va_start(argptr, fmt);
	vsprintf(buffer, fmt, argptr);
	va_end(argptr);
	log(buffer);
}

void
printfh(int handle, char *fmt,...)
{
	va_list         argptr;
	char            buffer[1024];
	if (handle < 1)
		return;		/* bad handle number */
	va_start(argptr, fmt);
	vsprintf(buffer, fmt, argptr);
	va_end(argptr);
	write(handle, buffer, strlen(buffer));
}

void
process_u2f(char *dirname, char *xqtname)
{
	char            buf[4000];
	char            buf2[1000];
	char            mysite[LINESIZE];
	char            myfeed[LINESIZE];
	char            dataname[LINESIZE];
	char            archivename[LINESIZE];
	char            commandname[LINESIZE];
	char           *p;

	char           *user, *system;
	sprintf(buf, "%s%s", dirname, xqtname);
	int             handle = sopen(buf, O_BINARY | O_RDONLY, SH_DENYWR, S_IREAD);
	if (handle < 1) {
		errormsgstring("Couldn't open %s", buf);
		return;
	}
	errormsgstring("Opened %s handle=%u", buf, handle);
	buf[read(handle, buf, sizeof(buf) - 1)] = 0;	/* read and delimit
							 * buffer; */
	close(handle);
	errormsgstring("Mail bundle name: %s", token(buf, "I"));
	strcpy(commandname, token(buf, "C"));
	errormsgstring("Command name: %s", commandname);
	errormsgstring("Requires: %s", token(buf, "F"));
	strcpy(mysite, configstr("MYSITE"));
	strcpy(myfeed, configstr("MYFEED"));
	strcpy(dataname, token(buf, "I"));
	p = waffle_munger(dataname, mysite, myfeed);
	sprintf(archivename, "%s%s", dirname, p);
	errormsgstring("DOS name to find: %s", archivename);
	killfiles = 0;

	strcpy(buf2, token(buf, "U"));
	user = strtok(buf2, " ");
	system = strtok(NULL, " ");
	p = token(buf, "R");
	if (*p)
		user = p;
	sprintf(responsibleparty, "%s!%s", system, user);


	if (strcmp(commandname, "rnews") == 0)
		rnews(archivename);
	else if (strcmp(commandname, "news") == 0)
		rnews(archivename);
	else if (strncmp(commandname, "rmail", 5) == 0)
		rmail(commandname, archivename);
	else if (strncmp(commandname, "mail", 4) == 0)
		rmail(commandname, archivename);
	else {
		sprintf("UNKNOWN COMMAND IN %s: \"%s\"", xqtname, commandname);
		return;
	}
	if (killfiles) {
		if (defined("TEST")) {
			errormsgstring("*TEST MODE* Files will NOT be killed!");
		} else {

			unlink(archivename);
			sprintf(buf, "%s%s", dirname, xqtname);
			unlink(buf);
		}
	}
}
void
find_u2f(void)
{
	DIR            *dirp;
	struct dirent  *direntp;

	char            dirname[256];
	char            searchname[256];
	newwindow(ti_action);
	cprintf("Scanning UUCP\r\n");
	strcpy(dirname, configstr("SPOOL"));
	if (dirname[0])
		if (dirname[strlen(dirname) - 1] != '\\')
			strcat(dirname, "\\");

	strcat(dirname, configstr("MYFEED"));
	strcat(dirname, "\\");
	makepath(dirname);
	sprintf(searchname, "%s*.x", dirname);
	errormsgstring("Scanning for %s", searchname);

	dirp = opendir(searchname);
	if (dirp) {
		make_pktheader();
		for (;;) {
			promptquit();
			if (quitearly)
				break;
			direntp = readdir(dirp);
			if (!direntp)
				break;
			if (direntp->d_name[0] != '.') {
				errormsgstring("Found %s", direntp->d_name);
				process_u2f(dirname, direntp->d_name);
			}
		}
		close_pkt();
	}
}

void
find_bag2f(void)
{
	DIR            *dirp;
	struct dirent  *direntp;

	char            dirname[256];
	char            searchname[256];
	char            tokbuffer[2048];
	char           *tok;
	char           *tokremainder;

	if (!*configstr("BAGS"))
		return;

	newwindow(ti_action);
	cprintf("Scanning .Bags\r\n");
	strcpy(tokbuffer, configstr("BAGS"));
	tokremainder = tokbuffer;

        while (tokremainder) {
            
            errormsgstring("tok=%s",tok);
            
            
		tok = strtok(tokremainder, " ");
            tokremainder = strtok(NULL, "\n");
            
            errormsgstring("tok=%s tokremainder=%s",tok,tokremainder);
            
                if (!tok) return;
                while(*tok==32) tok++;
                if (!*tok) continue;

		strcpy(dirname, tok);
		if (dirname[0])
			if (dirname[strlen(dirname) - 1] != '\\')
				strcat(dirname, "\\");
		makepath(dirname);
		sprintf(searchname, "%s*.Bag", dirname);
		errormsgstring("Scanning for %s", searchname);

		dirp = opendir(searchname);
		if (dirp) {
			make_pktheader();
			for (;;) {
				promptquit();
				if (quitearly)
					break;
				direntp = readdir(dirp);
				if (!direntp)
					break;
				if (direntp->d_name[0] != '.') {
					errormsgstring("Found %s", direntp->d_name);
					sprintf(searchname, "%s%s", dirname, direntp->d_name);
					rnews(searchname);
					if (killfiles)
						if (!defined("TEST"))
							unlink(searchname);
				}
			}
		}
		close_pkt();
	}
}

int
startlogfile(char *name)
{
	int             handle;
	char           *p;
	p = configstr(name);
	if (!p)
		return 0;
	if (!*p)
		return 0;

	handle = sopen(p, O_BINARY | O_CREAT | O_RDWR, SH_DENYRW, S_IWRITE);
	if (handle < 1)
		return 0;
	lseek(handle, filelength(handle), SEEK_SET);
	return handle;
}

void
diediedie(long daysago)
{
	window(1, 1, 80, 25);
	textattr(7);
	clrscr();
	daysago *= -1;
	cprintf("I am sorry, but this beta version of GIGO has expired\r\n"
		"as of %li days ago.\r\n\r\n"
		"See GATEWAY.DOC for more information, or netmail\r\n"
	    "Jason Fesler with a file request for a newer copy of GIGO.\r\n"
		"\r\n"
	"Note that people who have REGISTERED do not have their gateways\r\n"
		"down, as the registered version of GIGO never expires!  (But they\r\n"
		"are still encouraged to get the newer copies..)\r\n\r\n"
		"Pausing 5 seconds.\r\n\r\n",
		daysago);
	delay(5000);
	need_cleanup = 0;
	exit(1);
}
void
badbadbad(char *warning)
{
	window(1, 1, 80, 25);
	textattr(7);
	clrscr();
	cprintf("GIGO had problems initializing.. Please fix the following problem\r\n"
		"before re-loading GIGO.\r\n\r\n%s\r\n\r\n(Pausing 2 seconds)\r\n", warning);
	delay(2000);
	need_cleanup = 0;
	exit(1);
}
void
badbadbadcfg(char *variable)
{
	char            buf[256];
	sprintf(buf, "Config variable(s) %s not defined.", variable);
	badbadbad(buf);
}



long
figuredaysleft(void)
{
	static time_t   now;
	static time_t   dieat;
	now = time(NULL);
	dieat = __expires__;
	if (extraoption("EXTRA60"))
		dieat += (60 * 60 * 24 * 60);
	if (dieat < now) {
		dieat = now - dieat;
		dieat /= (60 * 60 * 24);
		return 0 - dieat;
	}
	dieat = dieat - now;
	dieat /= (60 * 60 * 24);
	return dieat;
}


void
takememory(void)
{

	errormsgstring("Allocating memory");

	fidonetsize = atol(configstr("MAX_FIDONET"));
	if (!fidonetsize)
		fidonetsize = 65000;
	if (fidonetsize < maxmessage + 2000)
		fidonetsize = maxmessage + 2000;	/* If the max message
							 * size is bigger than
							 * we allocate for,
							 * simply allocate MORE
							 * .. */
	if (fidonetsize < 20000)
		fidonetsize = 20000;	/* we FORCE a minimum on this one */

	FIDONETBUF = (char *) malloc(fidonetsize + 1024);
	if (!FIDONETBUF)
		goto nomem;

	usenetsize = atol(configstr("MAX_USENET"));
	if (usenetsize < 2000)
		usenetsize *= 1024;
	if (!usenetsize)
		usenetsize = 1000000;
#ifdef __DOS__
	if (usenetsize > coreleft() - 32000)
		usenetsize = coreleft() - 32000;
#endif
retrymemory:
	if (usenetsize < 130000)
		goto nomem;

	USENETBUF = (char *) malloc(usenetsize + 1000);
	if (!USENETBUF) {
		usenetsize -= 10000;
		goto retrymemory;
	}
	return;

nomem:
	need_cleanup = 0;
	log("Not enough memory to run.");
	badbadbad("Not enough memory to run.");
}

void
dumpmemory(void)
{

	/* deallocate memory */
	errormsgstring("Releasing memory");
	free(USENETBUF);
	USENETBUF = NULL;
	free(FIDONETBUF);
	FIDONETBUF = NULL;
}

extern unsigned videotype;
//1 = color 2 = mono 0 = detect


int             lockprogfile = 0;
void
lockprogram(char *exename)
{
	char            buf[256];
	char           *p;
	strcpy(buf, exename);

	p = strrchr(buf, '.');
	if (!p)
		return;
	//huh, what ! ? !?
		strcpy(p, ".lck");
	lockprogfile = sopen(buf, O_RDWR | O_CREAT, SH_DENYRW, S_IREAD | S_IWRITE);
	if (lockprogfile < 1) {
		fprintf(stderr, "Program %s is already running; aborting.\r\n", exename);
		need_cleanup = 0;
		exit(1);
	}
}
void
unlockprogram(char *exename)
{
	char            buf[256];
	char           *p;
	strcpy(buf, exename);
	p = strrchr(buf, '.');
	if (!p)
		return;
	//huh, what ! ? !?
		strcpy(p, ".lck");
	if (lockprogfile > 0)
		close(lockprogfile);
	lockprogfile = 0;
	unlink(buf);
}

void            verifyexistance(char *tag);

void
testmessages(void)
{
	errormsgstring("Verifying all mailer daemon messages are defined");
	verifyexistance("bounceuucp:user");
	verifyexistance("bounceuucp:site");
	verifyexistance("forwarduucp");
	verifyexistance("bouncefido:badaddress");
	verifyexistance("bouncefido:notauthorized");
	verifyexistance("bouncefido:blockaddress");
	verifyexistance("bouncefido:fileattach");
	verifyexistance("bouncefido:filerequest");
	verifyexistance("bouncefido:returnrequest");
	verifyexistance("fileattach");
	verifyexistance("fileserv:nofidonet");
	verifyexistance("fileserv:thanks");
	verifyexistance("fileserv:help");
	errormsgstring("... Verified.");
}
char const     *my_exe_file();

void
main(int argc, char *argv[])
{
	long            daysleft;
	int             i;
	time_t          t;
	struct tm      *local;

	i = _grow_handles(30);
	if (errno) {
		printf("Error on _grow_handles(30): %s\n", strerror(errno));
		sleep(4);
	}
	for (i = 0; i < 50; i++)
		if (argv[i]) {
			_argv[i] = argv[i];
		} else {
			argv[i] = NULL;
			i = 100;
		}
	_argc = argc;
	_argv[0] = argv[0];
#ifdef __OS2__
	_argv[0] = (char *) my_exe_file();
#endif
	if (paramswitch("/NOLOCK") == 0)
		lockprogram(_argv[0]);

	imitate_borland();
#ifdef __DOS__
	if (paramswitch("/BIOS"))
		directvideo = 0;
	else
		directvideo = 1;
	if (paramswitch("/COLOR"))
		videotype = 1;
	if (paramswitch("/MONO"))
		videotype = 2;
#endif


	if (paramswitch("/TRACE"))
		tron = 1;
	if (paramswitch("/SHROOM"))
		sim_usedosmem = 1;
	else
		sim_usedosmem = 0;
	initwindows();
topmain:
	newwindow(ti_action);
	confignumber++;
	if (paramconfigs() == 0)
		readconfig("gateway.cfg");
	else {
		if ((confignumber < _argc)
		    && (_argv[confignumber][0] != '/'))
			readconfig(_argv[confignumber]);
		else
			goto quit;
	}
	if ((paramswitch("/TRACE")) || (configstr("TRACE")))
		tron = 1;
	serialnumber[0] = 0;
	if (registered()) {
		registereduser = 1;
		strcpy(serialnumber, configstr("SERIALNUMBER"));
		errormsgstring("Thank you for registering! :-)");
		daysleft = figuredaysleft();
		if (daysleft < 5) {
			errormsgstring("This is an old version of GIGO.  Please check");
			errormsgstring("the docs on how to obtain a newer version, with");
			errormsgstring("possible new features and bug fixes!");
			delay(150);
		}
		goto ok_to_run;
	}
	daysleft = figuredaysleft();
	if (daysleft < 0) {
		diediedie(daysleft);
		need_cleanup = 0;
		exit(1);
	}
	if (daysleft < 5) {
		errormsgstring(" ");
		errormsgstring(" ");
		errormsgstring("THIS BETA VERSION WILL EXPIRE IN %li DAYS!", daysleft);
		errormsgstring("SEE THE DOCS TO GET A NEW COPY!!");
#ifdef __DOS__
		sound(440);
		delay(100);
		sound(880);
		delay(100);
		sound(440);
		delay(100);
		sound(880);
		delay(100);
		sound(440);
		delay(100);
		sound(880);
		delay(100);
		nosound();
		delay(1500);
#endif
#ifdef __OS2__
		sleep(2);
#endif
	} else {
		errormsgstring("Unregistered copy.");
		errormsgstring("This version expires in %li days.", daysleft);
	}
	t = __expires__;
	local = localtime(&t);
	strftime(__expiredate__, 80, "%B %d, %Y", local);
	errormsgstring("Expiration date:  %s.", __expiredate__);


ok_to_run:
	t = __expires__;
	local = localtime(&t);
	strftime(__expiredate__, 80, "%B %d, %Y", local);
	errormsgstring("New GIGO versions should be out on or before %s.", __expiredate__);

	newwindow(ti_log);
	strupr(tzone);
	if (putenv(tzone) != 0) {
		errormsgstring("COULD NOT SET ENVIRONMENT VARIABLE TZ CORRECTLY!");
		errormsgstring("For best results, SET %s before loading GIGO.", tzone);
		delay(1000);
	}
	errormsgstring("Time Zone:  %s", tzone);
	tzset();

	takememory();
	usevideo = 1;


	phraseopen();
	testmessages();


	if ((defined("NOVIDEO")) || (paramswitch("/NOVIDEO"))) {
		errormsgstring("NOVIDEO specified; good luck! :-)");
		usevideo = 0;
	}
	emailheaderlog = startlogfile("LOGEMAIL");
	if (!emailheaderlog)
		emailheaderlog = startlogfile("LOGMAIL");
	if (!emailheaderlog)
		emailheaderlog = startlogfile("EMAILLOG");
	if (!emailheaderlog)
		errormsgstring("Not logging headers to disk.");
	logkept = startlogfile("LOGKEPT");
	logdumped = startlogfile("LOGDUMPED");
	logbounced = startlogfile("LOGBOUNCED");
	logftpmail = startlogfile("LOGFILESERV");
	logconfigs = startlogfile("LOGCONFIGS");
	logtraffic = startlogfile("LOGTRAFFIC");
	if (logtraffic)
		printfh(logtraffic, "** %s\r\n", currentunixdate());

	promptquit();
	if (!quitearly)
		find_f2u();
	promptquit();
	if (do_news | do_mail)
		if (!quitearly)
			find_u2f();
	promptquit();
	if (do_news | do_mail)
		if (!quitearly)
			find_bag2f();
	promptquit();
	if (do_news | do_mail)
		if (!quitearly)
			explosions();
	promptquit();
	if (!quitearly)
		if (do_mail)
			find_req();
	promptquit();
	if (!defined("TEST"))
		if (do_news | do_mail)
			if (!quitearly)
				find_u2f();	/* one last pass! */


	nextreminder = startsequence;
	nextreminder >>= 13;	/* every 8192 messages */
	nextreminder++;
	nextreminder <<= 13;
	if (startsequence < 20)
		nextreminder = 20;
	if (((unsigned long) sequence >= nextreminder))
		if (!registered()) {
			register_me();
			find_u2f();
		}
	if (emailheaderlog)
		close(emailheaderlog);
	emailheaderlog = 0;
	phraseclose();
	if (logkept)
		close(logkept);
	logkept = 0;
	if (logdumped)
		close(logdumped);
	logdumped = 0;
	if (logbounced)
		close(logbounced);
	logbounced = 0;
	if (logftpmail)
		close(logftpmail);
	logftpmail = 0;
	if (logconfigs)
		close(logconfigs);
	logconfigs = 0;
	if (logtraffic)
		close(logtraffic);
	logtraffic = 0;

	dumpmemory();
	usevideo = 1;
	errormsgstring("Total messages to FidoNet: %lu", tofidonet);
	errormsgstring("Total messages to Usenet: %lu", tousenet);
	writesequence();

	free(config);
	config = NULL;
	free(mapping);
	mapping = NULL;
	free(echos);
	echos = NULL;

	free(sitestart);
	sitestart = NULL;
	free(userstart);
	userstart = NULL;
	free(kill_);
	kill_ = NULL;
	free(keep_);
	keep_ = NULL;
	free(hide_);
	hide_ = NULL;
	free(allow_);
	allow_ = NULL;
	free(fastreturn_);
	fastreturn_ = NULL;
	free(blockaddress_);
	fastreturn_ = NULL;

	if (paramconfigs() == 0)
		goto quit;
	if (loghandle)
		close(loghandle);
	loghandle = 0;
	goto topmain;
quit:
	loghandle = 0;
	if (paramswitch("/NOLOCK") == 0)
		unlockprogram(_argv[0]);
}
